function [Sest,iter]=cosamp_(Phi,u,K,tol1,tol2)

%edited by Daryl K Lim - 
%modifie par P.Dymarski - conditions d'arret uniquement

% Cosamp algo 
% K : sparsity of Sest    -   i.e. nombre des atomes cherches 
% Phi : obs matrix        -   i.e. le dictionnaire
% u: obs vector           -   i.e. le vecteur x pour modeliser

% Written by David Mary
% This script/program is released under the Commons Creative Licence
% with Attribution Non-commercial Share Alike (by-nc-sa)
% http://creativecommons.org/licenses/by-nc-sa/3.0/
% Disclaimer: the short answer, this script is for educational purpose only.
% More Disclaimer:  http://igorcarron.googlepages.com/disclaimer

% tol1 - concerne la distance entre u et son approximation (x et x_hat) 
% tol2 - concerne la distance entre deux vecteurs de gains (Sest) dans 2 iterations cocsecutives
% iter - nombre d'iterations

% Init.
[siz1,siz2]=size(Phi); 

Sest=zeros(siz2,1);
Sest1=ones(siz2,1); % gains precedents, initialisation quelconque ~= Sest
n2old=10^10;

  
v=u;
t=1; T2=[];
while t < 101 
   [k,z]=sort(abs(Phi'*v));
   k=flipud(k); z=flipud(z);
Omega=z(1:2*K);
T=sort(union(Omega,T2));phit=Phi(:,T);
%keyboard
b=pinv(phit)*u;                     
[k3,z3]=sort(abs(b));
k3=flipud(k3); z3=flipud(z3);
Sest=zeros(siz2,1);
Sest(T(z3(1:K))) = b(z3(1:K));
[k2,z2]=sort(abs(Sest));
k2=flipud(k2); z2=flipud(z2);
T2=z2(1:K);
v=u-Phi*Sest;
d=0;n2=norm(v); % condition d'arret changee
iter=t;
if n2 < tol1   % approximation de x (ici: u) presque ideale 
    d=1; t=1e10;
%    disp('CoSaMP: success');
end
if norm(Sest-Sest1) < tol2   % les memes gains dans 2 iterations consecutives 
    d=1; t=1e10;
%    disp('CoSaMP: stable point attained');
end

%if  n2 > n2old   % l'erreur accroit 
%    Sest=Sest1;
%    d=1; t=1e10;
%    disp('CoSaMP: unstable');
%end

 t=t+1;
 Sest1=Sest;
 n2old=n2;

 end
% if d==0
%     disp('CoSaMP: failed')
% end
 