
% Simulation pour obtenir les figures 4, 5 et 6 de l'article
% "Greedy sparse decompositions: a comparative study"
% Non optimized code - Simulation may be slow 

clear
% rand('seed', 12345)
% randn('seed', 12345)
N = 40;
L = 128;
Nbre_algo = 6;
Nbre_essai = 1000;
fprintf('Nbre essai = %d\n', Nbre_essai)
Eps = 1e-10;

x0 = 0; y0 = 0;
x1 = x0 + 20; x2 = x0 + 440; x3 = x0 + 860;
y1 = y0 + 40; y2 = y0 + 425;
largeur = 400;  hauteur = 300;
figure(1); clf; set(1,'Position',[x1 y2 largeur hauteur])
figure(2); clf; set(2,'Position',[x2 y2 largeur hauteur])
figure(3); clf; set(3,'Position',[x3 y2 largeur hauteur])
figure(4); clf; set(4,'Position',[x1 y1 largeur hauteur])
figure(5); clf; set(5,'Position',[x2 y1 largeur hauteur])
figure(6); clf; set(6,'Position',[x3 y1 largeur hauteur])
drawnow
no_fig = 1;

% Type de signaux = 1 => bruit blanc gaussien
%                   2 => AR(2)
tic
for Type_signaux = 1:2
    rho = 0.9;
    phi = pi/4;
    switch Type_signaux
        case 1, a = 1;
        case 2, a = [1; -2*rho*cos(phi); rho^2];
    end
    for i = 1:L
        F(:,i) = filter(1, a, randn(N,1));
    end
    
    % Methode = 1 => x qcq
    %           2 => x combinaison linaire de K_prime vecteurs de F
    for Methode = 1:2
        switch Methode
            case 1, table_K = [1 5 10 15 20 25 30];
            case 2, table_K = [1 5 9 10 11 15 20 25 30];
        end
        sigma2_x = zeros(Nbre_algo, length(table_K));
        sigma2_b = zeros(Nbre_algo, length(table_K));
        nbremult= zeros(Nbre_algo, length(table_K));  
        
        nbre_succes = zeros(Nbre_algo, length(table_K));
        nbre_essai_valide = zeros(Nbre_algo, length(table_K));
        fprintf('Type_signaux = %d Mthode = %d\n', Type_signaux, Methode)
        for no_essai = 1:Nbre_essai
            switch Methode
                case 1
                    x = filter(1, a, randn(N,1));
                case 2
                    K_prime = 10;
                    % dans chaque essai indices_ref differentes
                    indices_ref = zeros(K_prime,1);
                    for k = 1:K_prime
                        nbre = 1;
                        while nbre
                            indices_ref(k) = fix((L-1e-10)*rand) + 1;
                            nbre = 0;
                            for i = 1:k-1
                                if indices_ref(k) == indices_ref(i)
                                    nbre = nbre + 1;
                                end
                            end
                        end
                    end
                    gains_ref = randn(K_prime,1);
                    x = F(:,indices_ref)*gains_ref;
            end
            
            for iter_K = 1:length(table_K)
                K = table_K(iter_K);
                indices = zeros(Nbre_algo, K);
                gains = zeros(Nbre_algo, K);
                w = zeros(Nbre_algo,1);
                u = zeros(Nbre_algo,1);  
                
                [indices(1,:),gains(1,:),w(1),u(1)] = algos_mp(F,x,K,'MP+');
                [indices(2,:),gains(2,:),w(2),u(2)] = algos_mp(F,x,K,'OMP');
                [indices(3,:),gains(3,:),w(3),u(3)] = algos_mp(F,x,K,'RMGS');
                [indices(4,:),gains(4,:),w(4),u(4)] = algos_mp(F,x,K,'CMP');
                [indices(5,:),gains(5,:),w(5),u(5)] = algos_mp(F,x,K,'CRMGS');
                [indices(6,:),gains(6,:),w(6),u(6)] = algos_mp(F,x,K,'LARS');
                
                % Prparation des rsultats
                for no_algo = 1:Nbre_algo
                    if w(no_algo) == 0
                        nbremult(no_algo,iter_K) = ...
                            nbremult(no_algo,iter_K) + u(no_algo); 
                        sigma2_x(no_algo,iter_K) = ...
                            sigma2_x(no_algo,iter_K) + x'*x;
                        e = x - F(:,indices(no_algo,:))*gains(no_algo,:)';
                        if e'*e > Eps
                            sigma2_b(no_algo,iter_K) = ...
                                sigma2_b(no_algo,iter_K) + e'*e;
                        end
                        nbre_essai_valide(no_algo,iter_K) = nbre_essai_valide(no_algo,iter_K) + 1;
                        if Methode == 2
                            succes = 1;
                            for k = 1:K_prime
                                nr = indices_ref(k);
                                ok = 0;
                                for indnr = 1:K
                                    if indices(no_algo,indnr) == nr
                                        ok = 1;
                                    end
                                end
                                if ok == 0
                                    succes = 0;
                                    break
                                end
                            end
                            nbre_succes(no_algo,iter_K) = nbre_succes(no_algo,iter_K) + succes;
                        end
                    end
                end
            end
            if rem(no_essai, round(Nbre_essai/10)) == 0
                fprintf('%2d ', no_essai)
            end
        end
        fprintf('\n')
        
        nbremult = nbremult./Nbre_essai;  
        rsb = 10*log10(sigma2_x./(sigma2_b+Eps));
        
        switch Type_signaux
            case 1, titre = 'White noise';
            case 2, titre = 'AR process';
        end
        couleurs = ['o-b ' '+-k ' '*-r ' 'o--b'  '*--r'  's-y '];
        
        figure(no_fig); hold off
        for k = 1:Nbre_algo
            t1 = (k-1)*4 + 1;
            t2 =  k*4;
            plot(table_K, rsb(k,:), couleurs(t1:t2), 'linewidth', 2); hold on
        end
        axis([1 30 0 80])
        legend('MP', 'OMP', 'RMGS', 'CMP', 'OOCMP', 'LARS','Location', 'NorthWest')
        title(titre);
        xlabel('K')
        ylabel('RSB [db]')
        grid
        no_fig = no_fig + 1;
%         for k = 1:Nbre_algo
%             fprintf('%4d ', nbre_essai_valide(k,:)); fprintf('\n')
%         end
        if Methode == 2
            nbre_succes = nbre_succes./nbre_essai_valide;
            figure(no_fig); hold off
            for k = 1:Nbre_algo
                temp = nbre_succes(k,:);
                t1 = (k-1)*4 + 1;
                t2 =  k*4;
                plot(table_K, temp, couleurs(t1:t2), 'linewidth', 2); hold on
            end
            axis([1 30 -0.05 1.05])
            legend('MP', 'OMP', 'RMGS', 'CMP', 'OOCMP', 'LARS', 'Location', 'NorthEast')
            title(titre);
            xlabel('K')
            ylabel('Success rate')
            grid
            no_fig = no_fig + 1;
        end
        drawnow
    end
end
fprintf('Traitement => %d secondes\n', round(toc))

if 0
    figure(1); print -depsc rsb_bb_dense_1
    figure(2); print -depsc rsb_bb_sparse_1
    figure(3); print -depsc succes_bb_sparse_1
    figure(4); print -depsc rsb_ar_dense_1
    figure(5); print -depsc rsb_ar_sparse_1
    figure(6); print -depsc succes_ar_sparse_1
end

